Hex Artifact Content

Artifact 80cc783e96f55297bfd7503594a4293d8f66e5f4:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 69 66 20 5b 20 21 20 2d 66 20  bash..if [ ! -f 
0020: 27 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  'build.sh' ]; th
0030: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
0040: 20 54 68 69 73 20 73 63 72 69 70 74 20 6d 75 73   This script mus
0050: 74 20 62 65 20 72 75 6e 20 66 72 6f 6d 20 74 68  t be run from th
0060: 65 20 64 69 72 65 63 74 6f 72 79 20 69 74 20 69  e directory it i
0070: 73 20 69 6e 27 20 3e 26 32 0a 0a 09 65 78 69 74  s in' >&2...exit
0080: 20 31 0a 66 69 0a 69 66 20 5b 20 2d 7a 20 22 24   1.fi.if [ -z "$
0090: 7b 54 43 4c 56 45 52 53 7d 22 20 5d 3b 20 74 68  {TCLVERS}" ]; th
00a0: 65 6e 0a 09 65 63 68 6f 20 27 45 52 52 4f 52 3a  en..echo 'ERROR:
00b0: 20 54 68 65 20 54 43 4c 56 45 52 53 20 65 6e 76   The TCLVERS env
00c0: 69 72 6f 6e 6d 65 6e 74 20 76 61 72 69 61 62 6c  ironment variabl
00d0: 65 20 69 73 20 6e 6f 74 20 73 65 74 27 20 3e 26  e is not set' >&
00e0: 32 0a 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 54  2...exit 1.fi..T
00f0: 43 4c 56 46 53 56 45 52 53 3d 22 32 30 30 38 30  CLVFSVERS="20080
0100: 35 30 33 22 0a 53 52 43 3d 22 73 72 63 2f 74 63  503".SRC="src/tc
0110: 6c 76 66 73 2d 24 7b 54 43 4c 56 46 53 56 45 52  lvfs-${TCLVFSVER
0120: 53 7d 2e 74 61 72 2e 67 7a 22 0a 53 52 43 55 52  S}.tar.gz".SRCUR
0130: 4c 3d 22 68 74 74 70 3a 2f 2f 73 6f 75 72 63 65  L="http://source
0140: 66 6f 72 67 65 2e 6e 65 74 2f 70 72 6f 6a 65 63  forge.net/projec
0150: 74 73 2f 74 63 6c 76 66 73 2f 66 69 6c 65 73 2f  ts/tclvfs/files/
0160: 74 63 6c 76 66 73 2f 74 63 6c 76 66 73 2d 24 7b  tclvfs/tclvfs-${
0170: 54 43 4c 56 46 53 56 45 52 53 7d 2f 74 63 6c 76  TCLVFSVERS}/tclv
0180: 66 73 2d 24 7b 54 43 4c 56 46 53 56 45 52 53 7d  fs-${TCLVFSVERS}
0190: 2e 74 61 72 2e 67 7a 2f 64 6f 77 6e 6c 6f 61 64  .tar.gz/download
01a0: 22 0a 53 52 43 48 41 53 48 3d 27 30 64 39 30 33  ".SRCHASH='0d903
01b0: 36 32 30 37 38 63 38 66 35 39 33 34 37 62 31 34  62078c8f59347b14
01c0: 62 65 33 37 37 65 39 33 30 36 33 33 36 62 36 64  be377e9306336b6d
01d0: 32 35 64 31 34 37 33 39 37 66 38 34 35 65 37 30  25d147397f845e70
01e0: 35 61 36 66 61 31 64 33 38 66 32 27 0a 42 55 49  5a6fa1d38f2'.BUI
01f0: 4c 44 44 49 52 3d 22 24 28 70 77 64 29 2f 62 75  LDDIR="$(pwd)/bu
0200: 69 6c 64 2f 74 63 6c 76 66 73 2d 24 7b 54 43 4c  ild/tclvfs-${TCL
0210: 56 46 53 56 45 52 53 7d 22 0a 4f 55 54 44 49 52  VFSVERS}".OUTDIR
0220: 3d 22 24 28 70 77 64 29 2f 6f 75 74 22 0a 49 4e  ="$(pwd)/out".IN
0230: 53 54 44 49 52 3d 22 24 28 70 77 64 29 2f 69 6e  STDIR="$(pwd)/in
0240: 73 74 22 0a 50 41 54 43 48 44 49 52 3d 22 24 28  st".PATCHDIR="$(
0250: 70 77 64 29 2f 70 61 74 63 68 65 73 22 0a 65 78  pwd)/patches".ex
0260: 70 6f 72 74 20 54 43 4c 56 46 53 56 45 52 53 20  port TCLVFSVERS 
0270: 53 52 43 20 53 52 43 55 52 4c 20 42 55 49 4c 44  SRC SRCURL BUILD
0280: 44 49 52 20 4f 55 54 44 49 52 20 49 4e 53 54 44  DIR OUTDIR INSTD
0290: 49 52 20 50 41 54 43 48 44 49 52 0a 0a 23 20 53  IR PATCHDIR..# S
02a0: 65 74 20 63 6f 6e 66 69 67 75 72 65 20 6f 70 74  et configure opt
02b0: 69 6f 6e 73 20 66 6f 72 20 74 68 69 73 20 73 75  ions for this su
02c0: 62 2d 70 72 6f 6a 65 63 74 0a 4c 44 46 4c 41 47  b-project.LDFLAG
02d0: 53 3d 22 24 7b 4c 44 46 4c 41 47 53 7d 20 24 7b  S="${LDFLAGS} ${
02e0: 4b 43 5f 54 43 4c 56 46 53 5f 4c 44 46 4c 41 47  KC_TCLVFS_LDFLAG
02f0: 53 7d 22 0a 43 46 4c 41 47 53 3d 22 24 7b 43 46  S}".CFLAGS="${CF
0300: 4c 41 47 53 7d 20 24 7b 4b 43 5f 54 43 4c 56 46  LAGS} ${KC_TCLVF
0310: 53 5f 43 46 4c 41 47 53 7d 22 0a 43 50 50 46 4c  S_CFLAGS}".CPPFL
0320: 41 47 53 3d 22 24 7b 43 50 50 46 4c 41 47 53 7d  AGS="${CPPFLAGS}
0330: 20 24 7b 4b 43 5f 54 43 4c 56 46 53 5f 43 50 50   ${KC_TCLVFS_CPP
0340: 46 4c 41 47 53 7d 22 0a 4c 49 42 53 3d 22 24 7b  FLAGS}".LIBS="${
0350: 4c 49 42 53 7d 20 24 7b 4b 43 5f 54 43 4c 56 46  LIBS} ${KC_TCLVF
0360: 53 5f 4c 49 42 53 7d 22 0a 65 78 70 6f 72 74 20  S_LIBS}".export 
0370: 4c 44 46 4c 41 47 53 20 43 46 4c 41 47 53 20 43  LDFLAGS CFLAGS C
0380: 50 50 46 4c 41 47 53 20 4c 49 42 53 0a 0a 72 6d  PPFLAGS LIBS..rm
0390: 20 2d 72 66 20 27 62 75 69 6c 64 27 20 27 6f 75   -rf 'build' 'ou
03a0: 74 27 20 27 69 6e 73 74 27 0a 6d 6b 64 69 72 20  t' 'inst'.mkdir 
03b0: 27 62 75 69 6c 64 27 20 27 6f 75 74 27 20 27 69  'build' 'out' 'i
03c0: 6e 73 74 27 20 7c 7c 20 65 78 69 74 20 31 0a 0a  nst' || exit 1..
03d0: 54 43 4c 5f 56 45 52 53 49 4f 4e 3d 22 75 6e 6b  TCL_VERSION="unk
03e0: 6e 6f 77 6e 22 0a 69 66 20 5b 20 2d 66 20 22 24  nown".if [ -f "$
03f0: 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d 2f 74  {TCLCONFIGDIR}/t
0400: 63 6c 43 6f 6e 66 69 67 2e 73 68 22 20 5d 3b 20  clConfig.sh" ]; 
0410: 74 68 65 6e 0a 09 73 6f 75 72 63 65 20 22 24 7b  then..source "${
0420: 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d 2f 74 63  TCLCONFIGDIR}/tc
0430: 6c 43 6f 6e 66 69 67 2e 73 68 22 0a 66 69 0a 65  lConfig.sh".fi.e
0440: 78 70 6f 72 74 20 54 43 4c 5f 56 45 52 53 49 4f  xport TCL_VERSIO
0450: 4e 0a 0a 69 66 20 5b 20 21 20 2d 66 20 22 24 7b  N..if [ ! -f "${
0460: 53 52 43 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 6d  SRC}" ]; then..m
0470: 6b 64 69 72 20 27 73 72 63 27 20 3e 2f 64 65 76  kdir 'src' >/dev
0480: 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c  /null 2>/dev/nul
0490: 6c 0a 0a 09 69 66 20 5b 20 21 20 2d 64 20 27 62  l...if [ ! -d 'b
04a0: 75 69 6c 64 73 72 63 27 20 5d 3b 20 74 68 65 6e  uildsrc' ]; then
04b0: 0a 09 09 64 6f 77 6e 6c 6f 61 64 20 22 24 7b 53  ...download "${S
04c0: 52 43 55 52 4c 7d 22 20 22 24 7b 53 52 43 7d 22  RCURL}" "${SRC}"
04d0: 20 22 24 7b 53 52 43 48 41 53 48 7d 22 20 7c 7c   "${SRCHASH}" ||
04e0: 20 65 78 69 74 20 31 0a 09 66 69 0a 66 69 0a 0a   exit 1..fi.fi..
04f0: 28 0a 09 63 64 20 27 62 75 69 6c 64 27 20 7c 7c  (..cd 'build' ||
0500: 20 65 78 69 74 20 31 0a 0a 09 69 66 20 5b 20 21   exit 1...if [ !
0510: 20 2d 64 20 27 2e 2e 2f 62 75 69 6c 64 73 72 63   -d '../buildsrc
0520: 27 20 5d 3b 20 74 68 65 6e 0a 09 09 67 7a 69 70  ' ]; then...gzip
0530: 20 2d 64 63 20 22 2e 2e 2f 24 7b 53 52 43 7d 22   -dc "../${SRC}"
0540: 20 7c 20 74 61 72 20 2d 78 66 20 2d 0a 09 65 6c   | tar -xf -..el
0550: 73 65 20 20 20 20 0a 09 09 63 70 20 2d 72 70 20  se    ...cp -rp 
0560: 2e 2e 2f 62 75 69 6c 64 73 72 63 2f 2a 20 27 2e  ../buildsrc/* '.
0570: 2f 27 0a 09 66 69 0a 0a 09 63 64 20 22 24 7b 42  /'..fi...cd "${B
0580: 55 49 4c 44 44 49 52 7d 22 20 7c 7c 20 65 78 69  UILDDIR}" || exi
0590: 74 20 31 0a 0a 20 20 20 20 20 20 20 20 23 20 41  t 1..        # A
05a0: 70 70 6c 79 20 72 65 71 75 69 72 65 64 20 70 61  pply required pa
05b0: 74 63 68 65 73 0a 09 66 6f 72 20 70 61 74 63 68  tches..for patch
05c0: 20 69 6e 20 22 24 7b 50 41 54 43 48 44 49 52 7d   in "${PATCHDIR}
05d0: 2f 61 6c 6c 22 2f 74 63 6c 76 66 73 2d 24 7b 54  /all"/tclvfs-${T
05e0: 43 4c 56 46 53 56 45 52 53 7d 2d 2a 2e 64 69 66  CLVFSVERS}-*.dif
05f0: 66 20 22 24 7b 50 41 54 43 48 44 49 52 7d 2f 24  f "${PATCHDIR}/$
0600: 7b 54 43 4c 5f 56 45 52 53 49 4f 4e 7d 22 2f 74  {TCL_VERSION}"/t
0610: 63 6c 76 66 73 2d 24 7b 54 43 4c 56 46 53 56 45  clvfs-${TCLVFSVE
0620: 52 53 7d 2d 2a 2e 64 69 66 66 3b 20 64 6f 0a 09  RS}-*.diff; do..
0630: 09 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 70 61  .if [ ! -f "${pa
0640: 74 63 68 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 09  tch}" ]; then...
0650: 09 63 6f 6e 74 69 6e 75 65 0a 09 09 66 69 0a 0a  .continue...fi..
0660: 09 09 65 63 68 6f 20 22 41 70 70 6c 79 69 6e 67  ..echo "Applying
0670: 3a 20 24 7b 70 61 74 63 68 7d 22 0a 09 09 24 7b  : ${patch}"...${
0680: 50 41 54 43 48 3a 2d 70 61 74 63 68 7d 20 2d 70  PATCH:-patch} -p
0690: 31 20 3c 20 22 24 7b 70 61 74 63 68 7d 22 0a 09  1 < "${patch}"..
06a0: 64 6f 6e 65 20 20 20 20 20 20 20 20 20 20 20 20  done            
06b0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06c0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06d0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06e0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
06f0: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
0700: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
0710: 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20 20                  
0720: 20 20 20 0a 0a 09 63 70 20 67 65 6e 65 72 69 63     ...cp generic
0730: 2f 76 66 73 2e 63 20 2e 0a 0a 09 23 20 49 66 20  /vfs.c ....# If 
0740: 77 65 20 61 72 65 20 62 75 69 6c 64 69 6e 67 20  we are building 
0750: 66 6f 72 20 57 69 6e 33 32 2c 20 77 65 20 6e 65  for Win32, we ne
0760: 65 64 20 74 6f 20 64 65 66 69 6e 65 20 54 45 41  ed to define TEA
0770: 5f 50 4c 41 54 46 4f 52 4d 20 73 6f 20 74 68 61  _PLATFORM so tha
0780: 74 0a 09 23 20 74 68 65 20 72 69 67 68 74 20 70  t..# the right p
0790: 72 69 76 61 74 65 20 64 69 72 65 63 74 6f 72 79  rivate directory
07a0: 20 69 73 20 66 6f 75 6e 64 0a 09 42 55 49 4c 44   is found..BUILD
07b0: 54 59 50 45 3d 22 24 28 62 61 73 65 6e 61 6d 65  TYPE="$(basename
07c0: 20 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52   "${TCLCONFIGDIR
07d0: 7d 22 29 22 0a 09 69 66 20 5b 20 22 24 7b 42 55  }")"..if [ "${BU
07e0: 49 4c 44 54 59 50 45 7d 22 20 3d 20 22 77 69 6e  ILDTYPE}" = "win
07f0: 22 20 5d 3b 20 74 68 65 6e 0a 09 09 54 45 41 5f  " ]; then...TEA_
0800: 50 4c 41 54 46 4f 52 4d 3d 22 77 69 6e 64 6f 77  PLATFORM="window
0810: 73 22 0a 09 09 65 78 70 6f 72 74 20 54 45 41 5f  s"...export TEA_
0820: 50 4c 41 54 46 4f 52 4d 0a 0a 09 09 43 46 4c 41  PLATFORM....CFLA
0830: 47 53 3d 22 24 7b 43 46 4c 41 47 53 7d 20 2d 49  GS="${CFLAGS} -I
0840: 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52 7d 22  ${TCLCONFIGDIR}"
0850: 0a 09 09 65 78 70 6f 72 74 20 43 46 4c 41 47 53  ...export CFLAGS
0860: 0a 09 66 69 0a 0a 09 23 20 49 66 20 77 65 20 61  ..fi...# If we a
0870: 72 65 20 62 75 69 6c 64 69 6e 67 20 66 6f 72 20  re building for 
0880: 4b 69 74 44 4c 4c 2c 20 63 6f 6d 70 69 6c 65 20  KitDLL, compile 
0890: 77 69 74 68 20 27 2d 66 50 49 43 27 0a 09 69 66  with '-fPIC'..if
08a0: 20 5b 20 22 24 7b 4b 49 54 54 41 52 47 45 54 7d   [ "${KITTARGET}
08b0: 22 20 3d 20 22 6b 69 74 64 6c 6c 22 20 5d 3b 20  " = "kitdll" ]; 
08c0: 74 68 65 6e 0a 09 09 43 46 4c 41 47 53 3d 22 24  then...CFLAGS="$
08d0: 7b 43 46 4c 41 47 53 7d 20 2d 66 50 49 43 22 0a  {CFLAGS} -fPIC".
08e0: 09 09 65 78 70 6f 72 74 20 43 46 4c 41 47 53 0a  ..export CFLAGS.
08f0: 09 66 69 0a 0a 09 23 20 42 75 69 6c 64 20 73 74  .fi...# Build st
0900: 61 74 69 63 20 76 65 72 73 69 6f 6e 0a 09 65 63  atic version..ec
0910: 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 2e 2f 63  ho "Running: ./c
0920: 6f 6e 66 69 67 75 72 65 20 2d 2d 64 69 73 61 62  onfigure --disab
0930: 6c 65 2d 73 68 61 72 65 64 20 2d 2d 70 72 65 66  le-shared --pref
0940: 69 78 3d 5c 22 24 7b 49 4e 53 54 44 49 52 7d 5c  ix=\"${INSTDIR}\
0950: 22 20 2d 2d 65 78 65 63 2d 70 72 65 66 69 78 3d  " --exec-prefix=
0960: 5c 22 24 7b 49 4e 53 54 44 49 52 7d 5c 22 20 2d  \"${INSTDIR}\" -
0970: 2d 6c 69 62 64 69 72 3d 5c 22 24 7b 49 4e 53 54  -libdir=\"${INST
0980: 44 49 52 7d 2f 6c 69 62 5c 22 20 2d 2d 77 69 74  DIR}/lib\" --wit
0990: 68 2d 74 63 6c 3d 5c 22 24 7b 54 43 4c 43 4f 4e  h-tcl=\"${TCLCON
09a0: 46 49 47 44 49 52 7d 5c 22 20 24 7b 43 4f 4e 46  FIGDIR}\" ${CONF
09b0: 49 47 55 52 45 45 58 54 52 41 7d 22 0a 09 2e 2f  IGUREEXTRA}".../
09c0: 63 6f 6e 66 69 67 75 72 65 20 2d 2d 64 69 73 61  configure --disa
09d0: 62 6c 65 2d 73 68 61 72 65 64 20 2d 2d 70 72 65  ble-shared --pre
09e0: 66 69 78 3d 22 24 7b 49 4e 53 54 44 49 52 7d 22  fix="${INSTDIR}"
09f0: 20 2d 2d 65 78 65 63 2d 70 72 65 66 69 78 3d 22   --exec-prefix="
0a00: 24 7b 49 4e 53 54 44 49 52 7d 22 20 2d 2d 6c 69  ${INSTDIR}" --li
0a10: 62 64 69 72 3d 22 24 7b 49 4e 53 54 44 49 52 7d  bdir="${INSTDIR}
0a20: 2f 6c 69 62 22 20 2d 2d 77 69 74 68 2d 74 63 6c  /lib" --with-tcl
0a30: 3d 22 24 7b 54 43 4c 43 4f 4e 46 49 47 44 49 52  ="${TCLCONFIGDIR
0a40: 7d 22 20 24 7b 43 4f 4e 46 49 47 55 52 45 45 58  }" ${CONFIGUREEX
0a50: 54 52 41 7d 0a 0a 09 65 63 68 6f 20 22 52 75 6e  TRA}...echo "Run
0a60: 6e 69 6e 67 3a 20 24 7b 4d 41 4b 45 3a 2d 6d 61  ning: ${MAKE:-ma
0a70: 6b 65 7d 22 0a 09 24 7b 4d 41 4b 45 3a 2d 6d 61  ke}"..${MAKE:-ma
0a80: 6b 65 7d 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09  ke} || exit 1...
0a90: 65 63 68 6f 20 22 52 75 6e 6e 69 6e 67 3a 20 24  echo "Running: $
0aa0: 7b 4d 41 4b 45 3a 2d 6d 61 6b 65 7d 20 69 6e 73  {MAKE:-make} ins
0ab0: 74 61 6c 6c 22 0a 09 24 7b 4d 41 4b 45 3a 2d 6d  tall"..${MAKE:-m
0ac0: 61 6b 65 7d 20 69 6e 73 74 61 6c 6c 20 7c 7c 20  ake} install || 
0ad0: 65 78 69 74 20 31 0a 0a 09 6d 6b 64 69 72 20 22  exit 1...mkdir "
0ae0: 24 7b 4f 55 54 44 49 52 7d 2f 6c 69 62 22 20 7c  ${OUTDIR}/lib" |
0af0: 7c 20 65 78 69 74 20 31 0a 09 63 70 20 2d 72 20  | exit 1..cp -r 
0b00: 22 24 7b 49 4e 53 54 44 49 52 7d 2f 6c 69 62 22  "${INSTDIR}/lib"
0b10: 2f 76 66 73 2a 20 22 24 7b 4f 55 54 44 49 52 7d  /vfs* "${OUTDIR}
0b20: 2f 6c 69 62 2f 22 0a 09 72 6d 20 2d 66 20 22 24  /lib/"..rm -f "$
0b30: 7b 4f 55 54 44 49 52 7d 2f 6c 69 62 22 2f 76 66  {OUTDIR}/lib"/vf
0b40: 73 2a 2f 2a 2e 61 20 22 24 7b 4f 55 54 44 49 52  s*/*.a "${OUTDIR
0b50: 7d 2f 6c 69 62 22 2f 76 66 73 2a 2f 2a 2e 73 6f  }/lib"/vfs*/*.so
0b60: 0a 0a 09 65 78 69 74 20 30 0a 29 20 7c 7c 20 65  ...exit 0.) || e
0b70: 78 69 74 20 31 0a 0a 65 78 69 74 20 30 0a        xit 1..exit 0.